unit PopUpFormUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TPopUpForm = class(TForm)
    ListBox1: TListBox;
    procedure FormShow(Sender: TObject);
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormDeactivate(Sender: TObject);
  private
    { Private 錾 }
    FhActivePrevForm : HWND;
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CMShowingchanged(var Message: TMessage);
      message CM_SHOWINGCHANGED;
    procedure WMActivateApp(var Message: TWMActivateApp);
      message WM_ACTIVATEAPP;
  public
    { Public 錾 }
  end;

var
  PopUpForm: TPopUpForm;

implementation

{$R *.dfm}

//=============================================================================
//  ̃tH[R[h⊮EBhÊ悤ɁCI[o[bv\
//  EChEX^C͍D݂ɉĕύX
//
//  WS_POPUP̓^Cgo[⃊TCYgCNCAg̈悾̃EChE
//=============================================================================
procedure TPopUpForm.CreateParams(var Params: TCreateParams);
begin
  inherited;

  //̃tH[̓LvVo[ȂƂWS_THICKFRAMEO
  Params.Style := WS_POPUP or WS_BORDER;
  //̃tH[͍őOʕ\Ƃ
  //ꂪȂĂɎx͂Ȃ
  Params.ExStyle := Params.ExStyle or WS_EX_TOPMOST;
  //etƂ
  Params.WindowClass.Style := Params.WindowClass.Style or CS_DROPSHADOW;
end;

//=============================================================================
//  tH[\鎞̏
//=============================================================================
procedure TPopUpForm.FormShow(Sender: TObject);
begin
  //OɃANeButH[̃nh擾
  FhActivePrevForm := Application.ActiveFormHandle;

  //̃tH[\tH[^IɃANeBuɂ
  if FhActivePrevForm <> 0 then begin
    PostMessage(FhActivePrevForm, WM_NCACTIVATE, 1, 0);
  end;
end;

//=============================================================================
//  CM_SHOWINGCHANGEDbZ[W
//  tH[\ꂽListBox1ɃtH[JXړ
//=============================================================================
procedure TPopUpForm.CMShowingchanged(var Message: TMessage);
begin
  inherited;

  if Visible then begin
    ListBox1.SetFocus;
  end;
end;

//=============================================================================
//  ListBox1OnKeyDownCxg
//  [ESC]ŕ
//  [Enter]ŕ(Xg̍ڂ̃_uNbNƓƂ)
//=============================================================================
procedure TPopUpForm.ListBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_ESCAPE) then begin
    Close;
  end else
  if (Key = VK_RETURN) then begin
    Close;
  end;
end;

//=============================================================================
//  ANeBuɂȂ
//=============================================================================
procedure TPopUpForm.FormDeactivate(Sender: TObject);
begin
  Close;
end;

//=============================================================================
//  ̃AvANeBuɂȂ
//  ̃tH[\tH[ANeBuɂ
//=============================================================================
procedure TPopUpForm.WMActivateApp(var Message: TWMActivateApp);
begin
  inherited;
  if Visible then begin
    if FhActivePrevForm <> 0 then begin
      PostMessage(FhActivePrevForm, WM_NCACTIVATE, 0, 0);
    end;
    Close;
  end;
end;

end.
