unit PopUpFormUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TPopUpForm = class(TForm)
    ListBox1: TListBox;
    procedure FormShow(Sender: TObject);
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ListBox1DblClick(Sender: TObject);
  private
    { Private 錾 }
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure WMActivateApp(var Message: TWMActivateApp);
      message WM_ACTIVATEAPP;
  public
    { Public 錾 }
  end;

var
  PopUpForm: TPopUpForm;

implementation

uses MainFormUnit;

{$R *.dfm}

//=============================================================================
//  ̃tH[R[h⊮EBhÊ悤ɁCI[obv\
//  EChEX^C͍D݂ɉĕύX
//
//  WS_POPUP̓^Cgo[gCNCAg̈悾̃EChE
//=============================================================================
procedure TPopUpForm.CreateParams(var Params: TCreateParams);
begin
  inherited;

  //̃tH[̓LvVo[ȂƂ
  Params.Style := WS_THICKFRAME or WS_POPUP or WS_BORDER;
  //̃tH[͍őOʕ\Ƃ
  //ꂪȂĂɎx͂Ȃ
  Params.ExStyle := Params.ExStyle or WS_EX_TOPMOST;
  //etƂ
  Params.WindowClass.Style := Params.WindowClass.Style or CS_DROPSHADOW;
end;

//=============================================================================
//  tH[\鎞̏
//=============================================================================
procedure TPopUpForm.FormShow(Sender: TObject);
begin
  //eXgp̍쐬
  ListBox1.Items.BeginUpdate;
  ListBox1.Items.Clear;
  ListBox1.Items.Add('s');
  ListBox1.Items.Add('{');
  ListBox1.Items.Add('s{');
  ListBox1.Items.Add('Ɍ');
  ListBox1.Items.Add('es');

  if ListBox1.Items.Count > 0 then begin
    ListBox1.ItemIndex := 0;
  end;
  ListBox1.Items.EndUpdate;
end;

//=============================================================================
//  ListBox1OnKeyDownCxg
//  [ESC]ŕ
//  [Enter]ŕ(Xg̍ڂ̃_uNbNƓƂ)
//=============================================================================
procedure TPopUpForm.ListBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_ESCAPE) then begin
    Close;
  end else
  if (Key = VK_RETURN) then begin
    ListBox1DblClick(nil);
  end;
end;

//=============================================================================
//  ListBox1OnDblClickCxg
//  I𒆂̍ڂ_uNbN
//=============================================================================
procedure TPopUpForm.ListBox1DblClick(Sender: TObject);
var
  AIndex : Integer;
begin
  if ListBox1.ItemIndex >= 0 then begin
    AIndex := ListBox1.ItemIndex;
    MainForm.Edit1.Text := MainForm.Edit1.Text + ListBox1.Items[AIndex];
    MainForm.Edit1.SelStart := Length(MainForm.Edit1.Text);
  end;
  Close;
end;

//=============================================================================
//  ̃AvANeBuɂȂ
//  ̃tH[\tH[ANeBuɂ
//=============================================================================
procedure TPopUpForm.WMActivateApp(var Message: TWMActivateApp);
begin
  inherited;
  if Visible then begin
    PostMessage(MainForm.Handle, WM_NCACTIVATE, 0, 0);
    Close;
  end;
end;

end.
