unit PopUpFormUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TPopUpForm = class(TForm)
    ListBox1: TListBox;
    procedure FormShow(Sender: TObject);
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ListBox1DblClick(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
  private
    { Private 錾 }
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CMShowingchanged(var Message: TMessage);
      message CM_SHOWINGCHANGED;
    procedure WMActivateApp(var Message: TWMActivateApp);
      message WM_ACTIVATEAPP;
  public
    { Public 錾 }
  end;

var
  PopUpForm: TPopUpForm;

implementation

uses MainFormUnit;

{$R *.dfm}

//=============================================================================
//  ̃tH[R[h⊮EBhÊ悤ɁCI[o[bv\
//  EChEX^C͍D݂ɉĕύX
//
//  WS_POPUP̓^Cgo[⃊TCYgCNCAg̈悾̃EChE
//=============================================================================
procedure TPopUpForm.CreateParams(var Params: TCreateParams);
begin
  inherited;

  //̃tH[̓LvVo[ȂƂWS_THICKFRAMEO
  Params.Style := WS_POPUP or WS_BORDER;
  //̃tH[͍őOʕ\Ƃ
  //ꂪȂĂɎx͂Ȃ
  Params.ExStyle := Params.ExStyle or WS_EX_TOPMOST;
  //etƂ
  Params.WindowClass.Style := Params.WindowClass.Style or CS_DROPSHADOW;
end;

//=============================================================================
//  tH[\鎞̏
//=============================================================================
procedure TPopUpForm.FormShow(Sender: TObject);
begin
  ListBox1.BorderStyle := bsNone;
  ListBox1.BevelKind   := bkFlat;

  //eXgp̍쐬
  ListBox1.Items.BeginUpdate;
  ListBox1.Items.Clear;
  ListBox1.Items.Add('s');
  ListBox1.Items.Add('ʌ');
  ListBox1.Items.Add('_ސ쌧');
  ListBox1.Items.Add('Qn');
  ListBox1.Items.Add('Ȗ،');
  ListBox1.Items.Add('錧');
  ListBox1.Items.Add('t');
  ListBox1.Items.Add('쌧');
  ListBox1.Items.Add('R');
  ListBox1.Items.Add('򕌌');
  ListBox1.Items.Add('V');
  ListBox1.Items.Add('');
  ListBox1.Items.Add('R`');
  ListBox1.Items.Add('茧');
  ListBox1.Items.Add('X');
  ListBox1.Items.Add('ꌧ');
  ListBox1.Items.Add('s{');
  ListBox1.Items.Add('{');

  if ListBox1.Items.Count > 0 then begin
    if MainForm.Edit1.Text <> '' then begin
      ListBox1.ItemIndex := ListBox1.Items.IndexOf(MainForm.Edit1.Text);
    end else begin
      ListBox1.ItemIndex := 0;
    end;
  end;
  ListBox1.Items.EndUpdate;

  //̃tH[\tH[^IɃANeBuɂ
  PostMessage(MainForm.Handle, WM_NCACTIVATE, 1, 0);
end;

//=============================================================================
//  CM_SHOWINGCHANGEDbZ[W
//  tH[\ꂽListBox1ɃtH[JXړ
//=============================================================================
procedure TPopUpForm.CMShowingchanged(var Message: TMessage);
begin
  inherited;

  if Visible then begin
    ListBox1.SetFocus;
  end;
end;

//=============================================================================
//  ListBox1OnKeyDownCxg
//  [ESC]ŕ
//  [Enter]ŕ(Xg̍ڂ̃_uNbNƓƂ)
//=============================================================================
procedure TPopUpForm.ListBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_ESCAPE) then begin
    Close;
  end else
  if (Key = VK_RETURN) then begin
    ListBox1DblClick(nil);
  end;
end;

//=============================================================================
//  ListBox1OnDblClickCxg
//  I𒆂̍ڂ_uNbN
//=============================================================================
procedure TPopUpForm.ListBox1DblClick(Sender: TObject);
var
  AIndex : Integer;
begin
  AIndex := ListBox1.ItemIndex;
  if AIndex >= 0 then begin
    MainForm.Edit1.SelStart := Length(MainForm.Edit1.Text);
  end;
  Close;
end;

//=============================================================================
//  ListBox1OnClickCxg
//  I𒆂̍ڂCtH[Editɕ\
//=============================================================================
procedure TPopUpForm.ListBox1Click(Sender: TObject);
var
  AIndex : Integer;
begin
  AIndex := ListBox1.ItemIndex;
  if AIndex >= 0 then begin
    MainForm.Edit1.Text := ListBox1.Items[AIndex];
  end;
end;

//=============================================================================
//  ANeBuɂȂ
//=============================================================================
procedure TPopUpForm.FormDeactivate(Sender: TObject);
begin
  ListBox1DblClick(nil);
end;

//=============================================================================
//  ̃AvANeBuɂȂ
//  ̃tH[\tH[ANeBuɂ
//=============================================================================
procedure TPopUpForm.WMActivateApp(var Message: TWMActivateApp);
begin
  inherited;
  if Visible then begin
    PostMessage(MainForm.Handle, WM_NCACTIVATE, 0, 0);
    Close;
  end;
end;

end.
