unit PopUpFormUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TPopUpForm = class(TForm)
    ListBox1: TListBox;
    procedure FormShow(Sender: TObject);
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormDeactivate(Sender: TObject);
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
  private
    { Private 錾 }
    FhActivePrevForm : HWND;
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CMShowingchanged(var Message: TMessage);
      message CM_SHOWINGCHANGED;
    procedure WMActivateApp(var Message: TWMActivateApp);
      message WM_ACTIVATEAPP;
  public
    { Public 錾 }
  end;

var
  PopUpForm: TPopUpForm;

implementation

{$R *.dfm}

//=============================================================================
//  ̃tH[R[h⊮EBhÊ悤ɁCI[o[bv\
//  EChEX^C͍D݂ɉĕύX
//
//  WS_POPUP̓^Cgo[⃊TCYgCNCAg̈悾̃EChE
//=============================================================================
procedure TPopUpForm.CreateParams(var Params: TCreateParams);
begin
  inherited;

  //̃tH[̓LvVo[ȂƂWS_THICKFRAMEO
  Params.Style := WS_POPUP or WS_BORDER;
  // ̃tH[͍őOʕ\Ƃ
  // ꂪȂĂɎx͂Ȃ
  Params.ExStyle := Params.ExStyle or WS_EX_TOPMOST;
  //etƂ
  Params.WindowClass.Style := Params.WindowClass.Style or CS_DROPSHADOW;
end;

//=============================================================================
//  tH[\鎞̏
//=============================================================================
procedure TPopUpForm.FormShow(Sender: TObject);
begin
  //OɃANeButH[̃nh擾
  FhActivePrevForm := Application.ActiveFormHandle;

  // ̃tH[\tH[^IɃANeBuɂ
  if FhActivePrevForm <> 0 then begin
    PostMessage(FhActivePrevForm, WM_NCACTIVATE, 1, 0);
  end;
end;

//=============================================================================
//  CM_SHOWINGCHANGEDbZ[W
//  tH[\ꂽListBox1ɃtH[JXړ
//=============================================================================
procedure TPopUpForm.CMShowingchanged(var Message: TMessage);
begin
  inherited;

  if Visible then begin
    ListBox1.SetFocus;
  end;
end;

//=============================================================================
//  ListBox1OnKeyDownCxg
//  [ESC]ŕ
//  [Enter]ŕ(Xg̍ڂ̃_uNbNƓƂ)
//=============================================================================
procedure TPopUpForm.ListBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_ESCAPE) then begin
    Close;
  end else
  if (Key = VK_RETURN) then begin
    Close;
  end;
end;

//=============================================================================
//  ANeBuɂȂ
//=============================================================================
procedure TPopUpForm.FormDeactivate(Sender: TObject);
begin
  Close;
end;

//=============================================================================
//  ̃AvANeBuɂȂ
//  ̃tH[\tH[ANeBuɂ
//=============================================================================
procedure TPopUpForm.WMActivateApp(var Message: TWMActivateApp);
begin
  inherited;
  if Visible then begin
    if FhActivePrevForm <> 0 then begin
      PostMessage(FhActivePrevForm, WM_NCACTIVATE, 0, 0);
    end;
    Close;
  end;
end;

//=============================================================================
//  TListBox  OnDropListDrawItem Cxg
//
//  DrawItem Cxggpꍇ́CSĂ̕`OŏKv
//  tH[JX̘g͕`悵Ă (\Ԃɂ邱Ƃ\)
//=============================================================================
procedure TPopUpForm.ListBox1DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
  LRect    : TRect;
  LFormat  : TTextFormat;
  LItemText : string;
begin
  if odSelected in State then begin
    ListBox1.Canvas.Brush.Color := $00FFD2A6;
  end else begin
    ListBox1.Canvas.Brush.Color := ListBox1.Color;
  end;
  ListBox1.Canvas.FillRect(Rect);

  LRect := Rect;
  LRect.Left := LRect.Left + 5;
  LFormat    := [tfLeft, tfVerticalCenter, tfSingleLine];
  LItemText  := ListBox1.Items[Index];
  ListBox1.Canvas.Font.Color := clBlack;
  ListBox1.Canvas.TextRect(LRect, LItemText, LFormat);

  // ȉsƃtH[JX̘g\ƓԂɂł
  if odFocused in State then begin
//    ListBox1.Canvas.DrawFocusRect(Rect);
  end;
end;

end.
